// HFPolyMesh.cpp: implementation of the HFPolyMesh class.
//
//////////////////////////////////////////////////////////////////////

#include "hfpolymesh.h"

HFPolyMesh::~HFPolyMesh(){
	}

HFPolyMesh::HFPolyMesh(double (* EXT_FUNTION)(vector<double>,double *) ){
	short i;

	itsS0=0.0;
	itsTimer=false;

	itsSearch=false;
	itsSearchPer=0.01;

	itsNormals=false;

	
	//Reset it's XYZ Mapping to defaults
		itsXMap=0;
		itsYMap=1;
		itsZMap=2;
		
	//Reset Bounding Box to defaults
	for(i=0; i<3; i++){
		itsBBMin[i]=-10;
		itsBBMax[i]=10;
		}
		
	//Reset its Grid Sizes to defaults
	for(i=0; i<3; i++)
		itsGridSize[i]=30;

	//Set up its SendingX with defaults
	itsSendingX.resize(3, 0.0);
	
	//Parameters are defaulted already
	
	//Set it's epsilon value
	itsEPS=fabs(itsS0*EPS);
	if(itsS0==0.0) itsEPS=EPS;

	/******ADDED FOR S ATTRIBUTES******/
	itsSSize = 3;
	itsSAttributes =new double[itsSSize];

	itsRefinement = 1;

	/**********************************/
		calc = EXT_FUNTION;

	itsNormDelt.resize(3,0);
	itsNormDelt[0]=0.01;
	itsNormDelt[1]=0.01;
	itsNormDelt[2]=0.01;


	}

int HFPolyMesh::VertexNum(){
	return itsData.getNumV();
	}

int HFPolyMesh::TriangleNum(){ 
	return itsData.getNumT();
	}

void HFPolyMesh::Timer(bool t){
	itsTimer=t;
	}

bool HFPolyMesh::Timer(){
	return itsTimer;
	}

void HFPolyMesh::Search(bool s){
	itsSearch=s;
	}

bool HFPolyMesh::Search(){
	return itsSearch;
	}

void HFPolyMesh::SearchPercent(double p){
	itsSearchPer=p;
	}

double HFPolyMesh::SearchPercent(){
	return itsSearchPer;
	}

void HFPolyMesh::Normals(bool s){
	itsNormals=s;
	}

bool HFPolyMesh::Normals(){
	return itsNormals;
	}

void HFPolyMesh::Reduce(bool r){
	itsReduce=r;
	}

bool HFPolyMesh::Reduce(){
	return itsReduce;
	}

void HFPolyMesh::IsoValue(double isov){ 
	itsS0=isov;
	}

double HFPolyMesh::IsoValue(){ 
	return itsS0;
	}

void HFPolyMesh::Refine(int r){

	itsRefinement = r;
}
	
int HFPolyMesh::Refine(){
	return itsRefinement;
}


void HFPolyMesh::MinMax(vector<double> mm){ 
	short i;
	//Set up its Bounding Box
	if(mm.size()<6){//Reset to defaults
		for(i=0; i<3; i++){
			itsBBMin[i]=-10;
			itsBBMax[i]=10;
			}
		}
	else{
		for(i=0; i<3; i++) 
			itsBBMin[i]=mm[i];
		for(; i<6; i++)
			itsBBMax[i-3]=mm[i];
		if((itsBBMin[0]>=itsBBMax[0]) || (itsBBMin[1]>=itsBBMax[1]) || (itsBBMin[2]>=itsBBMax[2])){//Reset to defaults
			for(i=0; i<3; i++){
				itsBBMin[i]=-10;
				itsBBMax[i]=10;
				}
			}
		}
	}

vector<double> HFPolyMesh::MinMax(){
	vector<double> mmret(6, 0.0);
	short i;
	for(i=0; i<3; i++) 
		mmret[i]=itsBBMin[i];
	for(; i<6; i++)
		mmret[i]=itsBBMax[i-3];
	return mmret;
	}

void HFPolyMesh::Grid(vector<int> g){
	short i;
	//Set up its Grid Sizes
	if(g.size()<3){//Reset to defaults
		for(i=0; i<3; i++)
			itsGridSize[i]=30;
		}
	else{
		for(i=0; i<3; i++) 
			itsGridSize[i]=g[i];
		if((itsGridSize[0]<2) || (itsGridSize[1]<2) || (itsGridSize[2]<2)){//Reset to defaults
			for(i=0; i<3; i++)
				itsGridSize[i]=30;
			}
		}
	}

vector<int> HFPolyMesh::Grid(){
	short i;
	vector<int> gret(3, 0.0);
	for(i=0; i<3; i++)
		gret[i]=itsGridSize[i];
	return gret;
	}

void HFPolyMesh::DimMap(vector<int> dm){
	//Set up it's XYZ Mapping
	itsXMap=dm[0];
	itsYMap=dm[1];
	itsZMap=dm[2];
	if((itsXMap>=3) || (itsYMap>=3) 
		|| (itsZMap>=3)){//Reset to defaults
		itsXMap=0;
		itsYMap=1;
		itsZMap=2;
		}
	if((itsXMap==-1) || (itsYMap==-1) || (itsXMap==-1)){//Reset to defaults
		itsXMap=0;
		itsYMap=1;
		itsZMap=2;
		}
	}

vector<int> HFPolyMesh::DimMap(){
	vector<int> ret;
	ret.push_back(itsXMap);
	ret.push_back(itsYMap);
	ret.push_back(itsZMap);
	return ret;
	}

void HFPolyMesh::Constants(vector<double> con){
	for(int i=0; i<3 && i<con.size(); i++){
		itsSendingX[i]=con[i];
		}
	}

vector<double> HFPolyMesh::Constants(){
	return itsSendingX;
	}

void HFPolyMesh::Parameters(vector<double> par){
	//itsInterpreter.parameters(par);
	}

vector<double> HFPolyMesh::Parameters(){
	vector<double> toto(0, 0.0);
	return toto;
	//itsInterpreter.parameters();
	}



