#ifndef PERLINNOISECONFIGURATIONWIDGET_H
#define PERLINNOISECONFIGURATIONWIDGET_H

#include <qcolor.h>
#include <qpushbutton.h>
#include <qcombobox.h>
#include "AbstractConfigurationWidget.h"
#include "../src/Textures/PerlinNoiseColorTexture.h"
#include "UITools/DoubleSpinBox.h"

/// The Widget for the settings and the creation of a PerlinNoiseColorTexture.
class PerlinNoiseConfigurationWidget : public AbstractConfigurationWidget {
  
  Q_OBJECT
  
public:

  /// The constructor
  PerlinNoiseConfigurationWidget (QWidget * parent = NULL);

  /// The destructor
  virtual ~PerlinNoiseConfigurationWidget () {}

  // ********* 
  // Services 
  // *********

  TextureInterface * createTexture () const;
  QPixmap createPixmap () const;

  /// Conforms the object to PerlinNoiseColorTexture
  void conformTo (PerlinNoiseColorTexture * tex);

protected : 

  virtual void placeUIElements (QLayout * baseLayout);

private:
  
  QColor chosenColor1;
  QColor chosenColor2;
  QPushButton * colorChooserButton1;
  QPushButton * colorChooserButton2;
  DoubleSpinBox * phaseSpinBox;
  DoubleSpinBox * frequencySpinBox;
  DoubleSpinBox * amplitudeSpinBox;
  DoubleSpinBox * bound1SpinBox;
  DoubleSpinBox * bound2SpinBox;
  QComboBox * perlinNoiseTypes;

private slots:

  void appearColorDialog1 ();
  void appearColorDialog2 ();
  
};
#endif // PERLINNOISECONFIGURATIONWIDGET_H
